# Generated by Django 4.0 on 2022-05-14 13:40

from django.db import migrations, models
import django.db.models.deletion
import modelcluster.fields

try:
    import wagtail.blocks as wagtail_blocks
except ImportError:
    import wagtail.core.blocks as wagtail_blocks
try:
    import wagtail.fields as wagtail_fields
except ImportError:
    import wagtail.core.fields as wagtail_fields
import wagtail.images.blocks

from wagtail import VERSION as WAGTAIL_VERSION

if WAGTAIL_VERSION > (2, 14):
    dependencies = [
        ("wagtailcore", "0066_collection_management_permissions"),
    ]
elif WAGTAIL_VERSION > (2, 16):
    dependencies = [
        ("wagtailcore", "0069_log_entry_jsonfield"),
    ]

streamfield_kwargs = {"use_json_field": True} if WAGTAIL_VERSION >= (3, 0) else {}


class Migration(migrations.Migration):

    initial = True

    dependencies = dependencies

    operations = [
        migrations.CreateModel(
            name="Category",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255, unique=True)),
            ],
            options={
                "verbose_name": "category",
                "verbose_name_plural": "categories",
            },
        ),
        migrations.CreateModel(
            name="TestPage",
            fields=[
                (
                    "page_ptr",
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to="wagtailcore.page",
                    ),
                ),
                ("wp_post_id", models.IntegerField(blank=True, null=True)),
                (
                    "wp_post_type",
                    models.CharField(blank=True, max_length=255, null=True),
                ),
                ("wp_link", models.TextField(blank=True, null=True)),
                ("wp_raw_content", models.TextField(blank=True, null=True)),
                ("wp_processed_content", models.TextField(blank=True, null=True)),
                ("wp_block_json", models.TextField(blank=True, null=True)),
                ("wp_normalized_styles", models.TextField(blank=True, null=True)),
                ("wp_post_meta", models.JSONField(blank=True, null=True)),
                (
                    "body",
                    wagtail_fields.StreamField(
                        [
                            ("rich_text", wagtail_blocks.RichTextBlock()),
                            (
                                "heading",
                                wagtail_blocks.StructBlock(
                                    [
                                        (
                                            "text",
                                            wagtail_blocks.CharBlock(
                                                form_classname="title"
                                            ),
                                        ),
                                        (
                                            "importance",
                                            wagtail_blocks.ChoiceBlock(
                                                choices=[
                                                    ("h1", "H1"),
                                                    ("h2", "H2"),
                                                    ("h3", "H3"),
                                                    ("h4", "H4"),
                                                    ("h5", "H5"),
                                                    ("h6", "H6"),
                                                ]
                                            ),
                                        ),
                                    ]
                                ),
                            ),
                            (
                                "image",
                                wagtail_blocks.StructBlock(
                                    [
                                        (
                                            "image",
                                            wagtail.images.blocks.ImageChooserBlock(),
                                        ),
                                        (
                                            "caption",
                                            wagtail_blocks.CharBlock(required=False),
                                        ),
                                        (
                                            "link",
                                            wagtail_blocks.URLBlock(required=False),
                                        ),
                                        (
                                            "alignment",
                                            wagtail_blocks.ChoiceBlock(
                                                choices=[
                                                    ("left", "Left"),
                                                    ("right", "Right"),
                                                    ("center", "Center"),
                                                ]
                                            ),
                                        ),
                                    ]
                                ),
                            ),
                            (
                                "block_quote",
                                wagtail_blocks.StructBlock(
                                    [
                                        (
                                            "quote",
                                            wagtail_blocks.CharBlock(
                                                form_classname="title"
                                            ),
                                        ),
                                        (
                                            "attribution",
                                            wagtail_blocks.CharBlock(required=False),
                                        ),
                                    ]
                                ),
                            ),
                            ("raw_html", wagtail_blocks.RawHTMLBlock()),
                        ],
                        **streamfield_kwargs,
                    ),
                ),
                (
                    "categories",
                    modelcluster.fields.ParentalManyToManyField(
                        blank=True, to="example.Category"
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
            bases=("wagtailcore.page",),
        ),
    ]
